'From Cuis 2.0 of 12 February 2010 [latest update: #418] on 23 February 2010 at 6:17:21 pm'!

!Preferences class methodsFor: 'themes' stamp: 'jmv 2/23/2010 17:47'!
defaultValueTableForCurrentRelease
	"Answer a table defining default values for all the preferences in the release.  Returns a list of (pref-symbol, boolean-symbol) pairs"

	^  #(
		(abbreviatedBrowserButtons false)
		(alternativeBrowseIt false)
		(annotationPanes false)
		(automaticFlapLayout true)
		(automaticPlatformSettings true)
		(balloonHelpEnabled true)
		(browseWithPrettyPrint false)
		(browserShowsPackagePane false)
		(canRecordWhilePlaying false)
		(caseSensitiveFinds false)
		(changeSetVersionNumbers true)
		(checkForSlips true)
		(classicNewMorphMenu false)
		(cmdDotEnabled true)
		(collapseWindowsInPlace false)
		(conversionMethodsAtFileOut false)
		(cpuWatcherEnabled false)
		(debugHaloHandle true)
		(debugPrintSpaceLog false)
		(debugShowDamage false)
		(decorateBrowserButtons true)
		(diffsInChangeList true)
		(diffsWithPrettyPrint false)
		(dismissAllOnOptionClose false)
		(fastDragWindowForMorphic true)
		(fullScreenLeavesDeskMargins true)
		(hiddenScrollBars false)
		(higherPerformance false)
		(honorDesktopCmdKeys true)
		(inboardScrollbars true)
		(logDebuggerStackToFile true)
		(menuButtonInToolPane false)
		(menuColorFromWorld false)
		(menuKeyboardControl false)  
		(modalColorPickers true)
		(optionalButtons true)
		(personalizedWorldMenu true)
		(projectsSentToDisk false)
		(restartAlsoProceeds false)
		(reverseWindowStagger true)
		(scrollBarsWithoutMenuButton false)
		(selectiveHalos false)
		(showBoundsInHalo false)
		(simpleMenus false)
		(smartUpdating true)
		(soundQuickStart false)
		(soundStopWhenDone false)
		(soundsEnabled true)
		(systemWindowEmbedOK false)
		(thoroughSenders true)
		(twentyFourHourFileStamps true)
		(warnIfNoChangesFile true)
		(warnIfNoSourcesFile true))


"
Preferences defaultValueTableForCurrentRelease do:
	[:pair | (Preferences preferenceAt: pair first ifAbsent: [nil]) ifNotNilDo:
			[:pref | pref defaultValue: (pair last == #true)]].
Preferences chooseInitialSettings.
"! !


!SystemDictionary methodsFor: 'shrinking' stamp: 'jmv 2/23/2010 16:36'!
presumedSentMessages   | sent |
"Smalltalk presumedSentMessages"

	"The following should be preserved for doIts, etc"
	sent _ IdentitySet new.
	#( rehashWithoutBecome compactSymbolTable
		browseAllSelect:  lastRemoval
		vScrollBarValue: hScrollBarValue: scrollBarMenuButtonPressed: 
		to: removeClassNamed:
		dragon: hilberts: mandala: web test3 factorial tinyBenchmarks benchFib
		newDepth: restoreAfter: forgetDoIts zapAllMethods obsoleteClasses
		removeAllUnSentMessages abandonSources removeUnreferencedKeys
		zapOrganization condenseChanges browseObsoleteReferences
		subclass:instanceVariableNames:classVariableNames:poolDictionaries:category:
		methodsFor:stamp: methodsFor:stamp:prior: instanceVariableNames:
		startTimerEventLoop unusedClasses) do:
		[:sel | sent add: sel].
	"The following may be sent by perform: in dispatchOnChar..."
	(TextEditor cmdActions) asSet do: [:sel | sent add: sel].
	(TextEditor shiftCmdActions) asSet do: [:sel | sent add: sel].
	(SmalltalkEditor cmdActions) asSet do: [:sel | sent add: sel].
	(SmalltalkEditor shiftCmdActions) asSet do: [:sel | sent add: sel].
	
	"methodsToKeep is never called, but any class can implement it to protect some methods from deletion.
	For example, if no senders appear to exist because the symbols are built and later performed
	Include the following comment when implementing it:"
	"Send to self messages for all the methods that should be kept in Smalltalk image shrinking.
	This method is not actually called, but will not be deleted and therefore messages sent here will not appear as unsent"

	#(beReadOnlyBinding beReadWriteBinding changeSetCategoryClass belongsInAll: methodsToKeep) do:
		[:sel | sent add: sel].
	^ sent! !

Utilities class removeSelector: #applyUpdatesFromDisk!
Utilities class removeSelector: #applyUpdatesFromDiskToUpdateNumber:stopIfGap:!
Utilities class removeSelector: #dumpAnyOldStyleRecentSubmissions!
Utilities class removeSelector: #extractThisVersion:!
Utilities class removeSelector: #fileInFromUpdatesFolder:!
Utilities class removeSelector: #getUpdateDirectoryOrNil!
Utilities class removeSelector: #getterSelectorFor:!
Utilities class removeSelector: #inherentSelectorForGetter:!
Utilities class removeSelector: #inspectCollection:notifying:!
Utilities class removeSelector: #lastUpdateNum:!
Utilities class removeSelector: #nextClockwiseSideAfter:!
Utilities class removeSelector: #oppositeModeTo:!
Utilities class removeSelector: #oppositeSideTo:!
Utilities class removeSelector: #parseListContents:!
Utilities class removeSelector: #position:atVersion:!
Utilities class removeSelector: #readNextUpdatesFromDisk:!
Utilities class removeSelector: #reconstructTextWindowsFromFileNamed:!
Utilities class removeSelector: #saveUpdate:onFile:!
Utilities class removeSelector: #setterSelectorFor:!
Utilities class removeSelector: #showFormsAcrossTopOfScreen:!
Utilities class removeSelector: #simpleSetterFor:!
Utilities class removeSelector: #summariesForUpdates:through:!
Utilities class removeSelector: #updateComment!
Utilities class removeSelector: #writeList:toStream:!
SystemOrganizer removeSelector: #ifClassOrganizerDo:!
SystemDictionary removeSelector: #actualMessageNodeClass!
SystemDictionary removeSelector: #discardNetworking!
SystemDictionary removeSelector: #fileOutAndRemove:!
SystemDictionary removeSelector: #fileOutAndRemove:retainingRoots:!
SystemDictionary removeSelector: #fileOutAndRemove:withOtherClasses:andOtherMessages:!
SystemDictionary removeSelector: #kernelCategories!
SystemDictionary removeSelector: #reclaimDependents!
Set removeSelector: #capacity!
Point removeSelector: #bitShiftPoint:!
Point removeSelector: #sortsBefore:!
PasteUpMorph removeSelector: #currentNaturalLanguage!
PasteUpMorph removeSelector: #mouseX!
PasteUpMorph removeSelector: #mouseY!
OrderedCollection removeSelector: #capacity!
OrderedCollection removeSelector: #errorConditionNotSatisfied!
MessageSet class removeSelector: #extantMethodsIn:!
Object class removeSelector: #initialInstance!
Object class removeSelector: #readCarefullyFrom:!
ImageReadWriter removeSelector: #unpackBits:depthTo8From:with:height:pad:!
FileStream removeSelector: #dataIsValid!
FilePackage removeSelector: #fixClassOrder!
FilePackage removeSelector: #preamble:!
FilePackage removeSelector: #sampleMethod!
FileDirectory removeSelector: #acceptsUploads!
FileDirectory removeSelector: #directoryObject!
FileDirectory removeSelector: #downloadUrl!
FileDirectory removeSelector: #isTypeFile!
FileDirectory removeSelector: #matchingEntries:!
FileDirectory removeSelector: #storeServerEntryOn:!
FileDirectory removeSelector: #updateProjectInfoFor:!
Collection removeSelector: #capacity!
Object removeSelector: #at:modify:!
Object removeSelector: #fullPrintString!
Object removeSelector: #xxxClass!
Smalltalk removeClassNamed: #LimitingLineStreamWrapper!
