'From Cuis 3.0 of 14 January 2011 [latest update: #763] on 17 January 2011 at 10:02:38 am'!

!Preferences class methodsFor: 'initialization' stamp: 'jmv 1/17/2011 09:55'!
removeParameter: aSymbol
	"Remove all memory of the given parameter symbol in my various structures."

	self parameterAt: aSymbol ifAbsent: [^ self].

	Parameters removeKey: aSymbol ifAbsent: nil.
	self class removeSelector: aSymbol

"Preferences removeParameter: #tileToggleInBrowsers"! !

!Preferences class methodsFor: 'initialization' stamp: 'jmv 1/17/2011 09:54'!
removePreference: aSymbol
	"Remove all memory of the given preference symbol in my various structures."

	self preferenceAt: aSymbol ifAbsent: [^ self].

	DictionaryOfPreferences removeKey: aSymbol ifAbsent: nil.
	self class removeSelector: aSymbol

"Preferences removePreference: #tileToggleInBrowsers"! !

!Preferences class methodsFor: 'misc' stamp: 'jmv 1/17/2011 09:44'!
inspectUnused
	"
	To be used for:
		a) removing unneeded accessors in Preferences class
		b) cleaning the dictionaries themselves for a release
	(Warning: check senders before removing stuff!!)
	Preferences inspectUnused.
	Preferences inspectUnusedParameters
	"
	(DictionaryOfPreferences keys select: [ :a |
		((Smalltalk allCallsOn: a) reject: [ :b |
			b classSymbol = #Preferences ]) isEmpty ]) inspect.! !

!Preferences class methodsFor: 'misc' stamp: 'jmv 1/17/2011 09:44'!
inspectUnusedParameters
	"
	To be used for:
		a) removing unneeded accessors in Preferences class
		b) cleaning the dictionaries themselves for a release
	(Warning: check senders before removing stuff!!)
	Preferences inspectUnused.
	Preferences inspectUnusedParameters
	"
	(Parameters keys select: [ :a |
		((Smalltalk allCallsOn: a) reject: [ :b |
			b classSymbol = #Preferences ]) isEmpty ]) inspect.! !

!Preferences class methodsFor: 'themes' stamp: 'jmv 1/17/2011 09:48'!
brightSqueak
	"The classic bright Squeak look.  Windows have saturated colors and relatively low contrast; scroll-bars are of the flop-out variety and are on the left.  Many power-user features are enabled."

	self setPreferencesFrom:
	#(
		(annotationPanes true)
		(automaticFlapLayout true)
		(balloonHelpEnabled true)
		(browseWithPrettyPrint false)
		(browserShowsPackagePane false)
		(classicNewMorphMenu false)
		(cmdDotEnabled true)
		(collapseWindowsInPlace false)
		(debugHaloHandle true)
		(debugShowDamage false)
		(decorateBrowserButtons true)
		(diffsInChangeList true)
		(diffsWithPrettyPrint false)
		(fastDragWindowForMorphic true)
		(fullScreenLeavesDeskMargins true)
		(logDebuggerStackToFile true)
		(menuKeyboardControl true)
		(optionalButtons true)
		(personalizedWorldMenu true)
		(restartAlsoProceeds false)
		(reverseWindowStagger true)
		(selectiveHalos false)
		(simpleMenus false)
		(smartUpdating true)
		(systemWindowEmbedOK false)
		(thoroughSenders true)
		(warnIfNoChangesFile true)
		(warnIfNoSourcesFile true))! !

!Preferences class methodsFor: 'themes' stamp: 'jmv 1/17/2011 09:51'!
defaultValueTableForCurrentRelease
	"Answer a table defining default values for all the preferences in the release.  Returns a list of (pref-symbol, boolean-symbol) pairs"

	^  #(
		(alternativeBrowseIt false)
		(annotationPanes false)
		(automaticFlapLayout true)
		(automaticPlatformSettings true)
		(balloonHelpEnabled true)
		(browseWithPrettyPrint false)
		(browserShowsPackagePane false)
		(canRecordWhilePlaying false)
		(caseSensitiveFinds false)
		(changeSetVersionNumbers true)
		(checkForSlips true)
		(classicNewMorphMenu false)
		(cmdDotEnabled true)
		(collapseWindowsInPlace false)
		(conversionMethodsAtFileOut false)
		(cpuWatcherEnabled false)
		(debugHaloHandle true)
		(debugShowDamage false)
		(decorateBrowserButtons true)
		(diffsInChangeList true)
		(diffsWithPrettyPrint false)
		(dismissAllOnOptionClose false)
		(fastDragWindowForMorphic true)
		(fullScreenLeavesDeskMargins true)
		(higherPerformance false)
		(logDebuggerStackToFile true)
		(menuKeyboardControl false)  
		(modalColorPickers true)
		(optionalButtons true)
		(personalizedWorldMenu true)
		(restartAlsoProceeds false)
		(reverseWindowStagger true)
		(selectiveHalos false)
		(showBoundsInHalo false)
		(simpleMenus false)
		(smartUpdating true)
		(soundQuickStart false)
		(soundStopWhenDone false)
		(soundsEnabled true)
		(systemWindowEmbedOK false)
		(thoroughSenders true)
		(twentyFourHourFileStamps true)
		(warnIfNoChangesFile true)
		(warnIfNoSourcesFile true))


"
Preferences defaultValueTableForCurrentRelease do:
	[:pair | (Preferences preferenceAt: pair first ifAbsent: [nil]) ifNotNilDo:
			[:pref | pref defaultValue: (pair last == #true)]].
Preferences chooseInitialSettings.
"! !

!Preferences class methodsFor: 'themes' stamp: 'jmv 1/17/2011 09:48'!
juans

	self setPreferencesFrom:

	#(
		(annotationPanes true)
		(balloonHelpEnabled false)
		(browseWithPrettyPrint false)
		(browserShowsPackagePane false)
		(caseSensitiveFinds true)
		(checkForSlips true)
		(cmdDotEnabled true)
		(collapseWindowsInPlace false)
		(diffsInChangeList true)
		(diffsWithPrettyPrint false)
		(fastDragWindowForMorphic true)
		(menuKeyboardControl true)
		(optionalButtons true)
		(extraDebuggerButtons true)
		(personalizedWorldMenu false)
		(restartAlsoProceeds false)
		(simpleMenus false)
		(smartUpdating true)
		(subPixelRenderFonts true)
		(thoroughSenders true)
	)! !

!Preferences class methodsFor: 'themes' stamp: 'jmv 1/17/2011 09:49'!
magdeburg
	"Alternative window & scroll-bar looks, no desktop command keys, no keyboard menu control, no annotation panes..."

	self setPreferencesFrom: #(
		(annotationPanes false)
		(canRecordWhilePlaying false)
		(conversionMethodsAtFileOut true)
		(menuKeyboardControl false))! !

!Preferences class methodsFor: 'themes' stamp: 'jmv 1/17/2011 09:51'!
paloAlto
	"Similar to the brightSqueak theme, but with a number of idiosyncratic personal settings.   Note that caseSensitiveFinds is true"


	self setPreferencesFrom:
	#(
		(accessOnlineModuleRepositories noOpinion)
		(alternativeBrowseIt noOpinion)
		(annotationPanes true)
		(automaticFlapLayout true)
		(automaticPlatformSettings noOpinion)
		(balloonHelpEnabled true)
		(browseWithPrettyPrint false)
		(browserShowsPackagePane false)
		(canRecordWhilePlaying noOpinion)
		(caseSensitiveFinds true)
		(changeSetVersionNumbers true)
		(checkForSlips true)
		(classicNewMorphMenu false)
		(cmdDotEnabled true)
		(collapseWindowsInPlace false)
		(conservativeModuleDeActivation noOpinion)
		(conversionMethodsAtFileOut true)
		(cpuWatcherEnabled noOpinion)
		(debugHaloHandle true)
		(debugShowDamage false)
		(decorateBrowserButtons true)
		(diffsInChangeList true)
		(diffsWithPrettyPrint false)
		(dismissAllOnOptionClose true)
		(extraDebuggerButtons true)
		(fastDragWindowForMorphic true)
		(fullScreenLeavesDeskMargins true)
		(higherPerformance noOpinion)
		(logDebuggerStackToFile true)
		(menuKeyboardControl true)  
		(modalColorPickers true)
		(modularClassDefinitions noOpinion)
		(optionalButtons true)
		(personalizedWorldMenu true)
		(restartAlsoProceeds false)
		(reverseWindowStagger true)
		(selectiveHalos false)
		(showBoundsInHalo false)
		(simpleMenus false)
		(smartUpdating true)
		(soundQuickStart noOpinion)
		(soundsEnabled true)
		(soundStopWhenDone noOpinion)
		(strongModules noOpinion)
		(systemWindowEmbedOK false)
		(thoroughSenders true)
		(twentyFourHourFileStamps false)
		(warnIfNoChangesFile true)
		(warnIfNoSourcesFile true))! !

!Preferences class methodsFor: 'themes' stamp: 'jmv 1/17/2011 09:49'!
slowMachine

	self setPreferencesFrom:

	#(
		(annotationPanes false)
		(balloonHelpEnabled false)
		(browseWithPrettyPrint false)
		(browserShowsPackagePane false)
		(caseSensitiveFinds true)
		(checkForSlips false)
		(cmdDotEnabled true)
		(collapseWindowsInPlace false)
		(diffsInChangeList false)
		(diffsWithPrettyPrint false)
		(fastDragWindowForMorphic true)
		(menuKeyboardControl false)
		(optionalButtons false)
		(personalizedWorldMenu false)
		(restartAlsoProceeds false)
		(simpleMenus false)
		(smartUpdating false)
		(subPixelRenderFonts false)
		(thoroughSenders false)
	)! !

!Preferences class methodsFor: 'themes' stamp: 'jmv 1/17/2011 09:49'!
smalltalk80
	"A traditional monochrome Smalltalk-80 look and feel, clean and austere, and lacking many features added to Squeak in recent years. Caution: this theme removes the standard Squeak flaps, turns off the 'smartUpdating' feature that keeps multiple browsers in synch, and much more."

	self setPreferencesFrom:

	#(
		(annotationPanes false)
		(balloonHelpEnabled false)
		(browseWithPrettyPrint false)
		(browserShowsPackagePane false)
		(caseSensitiveFinds true)
		(checkForSlips false)
		(cmdDotEnabled true)
		(collapseWindowsInPlace false)
		(diffsInChangeList false)
		(diffsWithPrettyPrint false)
		(fastDragWindowForMorphic true)
		(menuKeyboardControl false)
		(optionalButtons false)
		(personalizedWorldMenu false)
		(restartAlsoProceeds false)
		(simpleMenus false)
		(smartUpdating false)
		(thoroughSenders false)
	)! !

Preferences class removeSelector: #debugPrintSpaceLog!
Preferences class removeSelector: #honorDesktopCmdKeys!
Preferences class removeSelector: #projectsSentToDisk!
"Postscript:
Leave the line above, and replace the rest of this comment by a useful one.
Executable statements should follow this comment, and should
be separated by periods, with no exclamation points (!!).
Be sure to put any further comments in double-quotes, like this one."
Preferences removePreference: #inboardScrollbars.
Preferences removePreference: #menuButtonInToolPane.
Preferences removePreference: #menuColorFromWorld.
Preferences removePreference: #scrollBarsNarrow.
Preferences removePreference: #alternativeWindowLook.
Preferences removePreference: #noviceMode.
Preferences removePreference: #ignoreStyleIfOnlyBold.
Preferences removePreference: #debugPrintSpaceLog.
Preferences removePreference: #mouseOverForKeyboardFocus.
Preferences removePreference: #uniqueNamesInHalos.
Preferences removePreference: #propertySheetFromHalo.
Preferences removePreference: #abbreviatedBrowserButtons.
Preferences removePreference: #swapControlAndAltKeys.
Preferences removePreference: #duplicateControlAndAltKeys.
Preferences removePreference: #confirmFirstUseOfStyle.
Preferences removePreference: #swapMouseButtons.
Preferences removePreference: #alternativeWindowBoxesLook.
Preferences removePreference: #colorWhenPrettyPrinting.
Preferences removePreference: #scrollBarsWithoutMenuButton.
Preferences removePreference: #menuAppearance3d.
Preferences removePreference: #projectsSentToDisk.
Preferences removePreference: #honorDesktopCmdKeys.
Preferences removeParameter: #menuTitleColor.
Preferences removeParameter: #insertionPointColor.
Preferences removeParameter: #menuLineColor.
Preferences removeParameter: #keyboardFocusColor.
Preferences removeParameter: #menuColor.
Preferences removeParameter: #menuBorderColor.
Preferences removeParameter: #textHighlightColor.
Preferences removeParameter: #menuTitleBorderColor.
Preferences removeParameter: #PersonalDictionaryOfPreferences.!

