'From Cuis 3.1 of 4 March 2011 [latest update: #850] on 15 March 2011 at 8:44:07 am'!
!classDefinition: #PluggableButtonMorph category: #'Morphic-Windows'!
PluggableMorph subclass: #PluggableButtonMorph
	instanceVariableNames: 'label font icon getStateSelector actionSelector isPressed mouseIsOver magnifiedIcon actWhen '
	classVariableNames: 'ButtonGradient ButtonGradientPressed RoundedCornerBL RoundedCornerBLPressed RoundedCornerBR RoundedCornerBRPressed RoundedCornerTL RoundedCornerTLPressed RoundedCornerTR RoundedCornerTRPressed '
	poolDictionaries: ''
	category: 'Morphic-Windows'!

!PluggableButtonMorph methodsFor: 'accessing' stamp: 'jmv 3/14/2011 17:39'!
actWhen: condition
	"Accepts symbols:  #buttonDown, #buttonUp (default)"
	actWhen _ condition! !

!PluggableButtonMorph methodsFor: 'copying' stamp: 'jmv 3/14/2011 17:57'!
veryDeepInner: deepCopier
	"Copy all of my instance variables.  Some need to be not copied at all, but shared.  	Warning!!!!  Every instance variable defined in this class must be handled.  We must also implement veryDeepFixupWith:.  See DeepCopier class comment."

super veryDeepInner: deepCopier.
"model _ model.		Weakly copied"
"getStateSelector _ getStateSelector.		a Symbol"
"actionSelector _ actionSelector.		a Symbol"
"getLabelSelector _ getLabelSelector.		a Symbol"
"getMenuSelector _ getMenuSelector.		a Symbol"
isPressed _ isPressed.
mouseIsOver _ mouseIsOver.
icon _ icon.
magnifiedIcon _ magnifiedIcon.
actWhen _ actWhen! !

!PluggableButtonMorph methodsFor: 'event handling' stamp: 'jmv 3/14/2011 17:41'!
mouseDown: evt

	evt mouseButton2Pressed ifTrue: [ ^ self mouseButton2Activity ].
	isPressed _ true.
	self redrawNeeded.
	actWhen == #buttonDown ifTrue: [
		self performAction ].
	evt hand
		waitForSimulatedMouseButton2: self
		event: evt
		dblClkSel: #doubleClick:! !

!PluggableButtonMorph methodsFor: 'event handling' stamp: 'jmv 3/14/2011 17:42'!
mouseUp: evt
	isPressed _ false.
	mouseIsOver _ false.
	(actWhen == #buttonUp and: [self containsPoint: evt cursorPoint])
		ifTrue: [ self performAction ].
	self redrawNeeded! !

!PluggableButtonMorph methodsFor: 'initialization' stamp: 'jmv 3/14/2011 17:38'!
initialize
	"initialize the state of the receiver"
	super initialize.

	model _ nil.
	getStateSelector _ nil.
	actionSelector _ nil.
	isPressed _ false.
	mouseIsOver _ false.
	actWhen _ #buttonUp.
	self extent: 20 @ 15! !

!classDefinition: #PluggableButtonMorph category: #'Morphic-Windows'!
PluggableMorph subclass: #PluggableButtonMorph
	instanceVariableNames: 'label font icon getStateSelector actionSelector isPressed mouseIsOver magnifiedIcon actWhen'
	classVariableNames: 'ButtonGradient ButtonGradientPressed RoundedCornerBL RoundedCornerBLPressed RoundedCornerBR RoundedCornerBRPressed RoundedCornerTL RoundedCornerTLPressed RoundedCornerTR RoundedCornerTRPressed'
	poolDictionaries: ''
	category: 'Morphic-Windows'!
