'From Cuis 3.1 of 4 March 2011 [latest update: #850] on 12 April 2011 at 8:55:31 am'!

!Editor methodsFor: 'menu messages' stamp: 'jmv 4/8/2011 09:55'!
clipboardStringOrText

	^ Clipboard retrieveStringOrText! !

!Editor methodsFor: 'menu messages' stamp: 'jmv 4/8/2011 09:55'!
paste
	"Paste the text from the shared buffer over the current selection and 
	redisplay if necessary.  Undoer & Redoer: undoAndReselect."

	self replace: self selectionInterval with: self clipboardStringOrText and:
		[self selectAt: self pointIndex]! !


!TextEditor methodsFor: 'menu messages' stamp: 'jmv 4/8/2011 09:55'!
compareToClipboard
	"Check to see if whether the receiver's text is the same as the text currently on the clipboard, and inform the user."
	| s1 s2 |
	s1 _ self clipboardStringOrText string.
	s2 _ paragraph string.
	s1 = s2 ifTrue: [^ self inform: 'Exact match'].

	(TextModel new contents:
		(DifferenceFinder displayPatchFrom: s1 to: s2 tryWords: true))
			openLabel: 'Comparison to Clipboard Text'! !

!TextEditor methodsFor: 'menu messages' stamp: 'jmv 4/8/2011 09:55'!
copySelection
	"Copy the current selection and store it in the paste buffer, unless a caret.  Undoer & Redoer: undoCutCopy"

	self lineSelectAndEmptyCheck: [^ self].

	"Simulate 'substitute: self selection' without locking the controller"
	UndoSelection _ self selection.
	self undoer: #undoCutCopy: with: self clipboardStringOrText.
	UndoInterval _ self selectionInterval.
	self clipboardTextPut: UndoSelection! !

!TextEditor methodsFor: 'menu messages' stamp: 'jmv 4/8/2011 09:55'!
cut
	"Cut out the current selection and redisplay the paragraph if necessary.  Undoer & Redoer: undoCutCopy:"

	self lineSelectAndEmptyCheck: [^ self].

	self replaceSelectionWith: self nullText. 
	self undoer: #undoCutCopy: with: self clipboardStringOrText.
	self clipboardTextPut: UndoSelection! !

!TextEditor methodsFor: 'undoers' stamp: 'jmv 4/8/2011 09:55'!
undoCutCopy: oldPasteBuffer
	"Undo of a cut, copy, or any edit that changed CurrentSelection.  Be sure
	 undo-copy does not lock the model.  Redoer: itself, so never isRedoing."

	| recentCut |
	recentCut _ self clipboardStringOrText.	
	UndoSelection size = UndoInterval size
		ifFalse: [self replaceSelectionWith: UndoSelection].
	self clipboardTextPut: oldPasteBuffer.
	self undoer: #undoCutCopy: with: recentCut! !

Editor removeSelector: #clipboardText!
