'From Cuis 3.2 of 12 April 2011 [latest update: #914] on 14 April 2011 at 4:19:39 pm'!
!classDefinition: #Morph category: #'Morphic-Kernel'!
Object subclass: #Morph
	instanceVariableNames: 'bounds owner submorphs fullBounds color extension '
	classVariableNames: 'EmptyArray '
	poolDictionaries: ''
	category: 'Morphic-Kernel'!

!Morph methodsFor: 'initialization' stamp: 'jmv\ 4/14/2011 15:20'!
initialize
	"initialize the state of the receiver"

	owner _ nil.
	submorphs _ #().
	bounds _ self defaultBounds.
	color _ self defaultColor! !

!Morph methodsFor: 'submorphs-add/remove' stamp: 'jmv\ 4/14/2011 15:20'!
removeAllMorphs
	| oldMorphs myWorld |
	submorphs isEmpty ifTrue: [ ^self ].
	myWorld _ self world.
	(fullBounds notNil or: [ myWorld notNil ]) ifTrue: [ self doLayoutIfNeeded; redrawNeeded ].
	submorphs do: [ :m |
		m privateOwner: nil ].
	oldMorphs _ submorphs.
	submorphs _ #().
	oldMorphs do: [ :m |
		self removedMorph: m ].
	self layoutChanged! !


!MenuMorph methodsFor: 'construction' stamp: 'jmv\ 4/14/2011 15:19'!
add: aString action: aSymbol
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the default target object."
	"Details: Note that the menu item added captures the default target object at the time the item is added; the default target can later be changed before added additional items without affecting the targets of previously added entries. The model is that each entry is like a button that knows everything it needs to perform its action."

	self add: aString
		target: defaultTarget
		selector: aSymbol
		argumentList: #()! !

!MenuMorph methodsFor: 'construction' stamp: 'jmv\ 4/14/2011 15:19'!
add: aString target: aTarget action: aSymbol
	self add: aString
		target: aTarget
		selector: aSymbol
		argumentList: #()! !

!MenuMorph methodsFor: 'construction' stamp: 'jmv\ 4/14/2011 15:20'!
add: aString target: anObject selector: aSymbol
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the target object."

	self add: aString
		target: anObject
		selector: aSymbol
		argumentList: #()! !

!MenuMorph methodsFor: 'construction' stamp: 'jmv\ 4/14/2011 15:20'!
addUpdating: aWordingSelector action: aSymbol

	self addUpdating: aWordingSelector target: defaultTarget selector: aSymbol argumentList: #()! !

!MenuMorph methodsFor: 'construction' stamp: 'jmv\ 4/14/2011 15:20'!
addUpdating: aWordingSelector target: aTarget action: aSymbol

	self addUpdating: aWordingSelector target: aTarget selector: aSymbol argumentList: #()
! !

!MenuMorph methodsFor: 'construction' stamp: 'jmv\ 4/14/2011 15:20'!
addWithLabel: aLabel enablement: anEnablementSelector action: aSymbol

	self addWithLabel: aLabel enablementSelector: anEnablementSelector target: defaultTarget selector: aSymbol argumentList: #()! !


!Morph class methodsFor: 'class initialization' stamp: 'jmv\ 4/14/2011 15:20'!
initialize
	"Morph initialize"
! !

Morph initialize!
!classDefinition: #Morph category: #'Morphic-Kernel'!
Object subclass: #Morph
	instanceVariableNames: 'bounds owner submorphs fullBounds color extension'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Kernel'!
