'From Cuis 3.2 of 12 April 2011 [latest update: #914] on 19 April 2011 at 12:14:31 pm'!
!classDefinition: #SimpleServiceEntry category: #'Tools-FileList'!
Model subclass: #SimpleServiceEntry
	instanceVariableNames: 'provider label selector useLineAfter stateSelector description argumentGetter buttonLabel argumentProvider triggerFileListChanged '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tools-FileList'!

!GZipReadStream class methodsFor: 'fileIn/Out' stamp: 'jmv 4/19/2011 11:19'!
serviceDecompressToFile

	^ (SimpleServiceEntry 
		provider: self 
		label: 'decompress to file'
		selector: #saveContents:
		description: 'decompress to file') triggerFileListChanged! !


!GZipWriteStream class methodsFor: 'file list services' stamp: 'jmv 4/19/2011 11:19'!
serviceCompressFile

	^ (SimpleServiceEntry 
		provider: self 
		label: 'compress file'
		selector: #compressFile:
		description: 'compress file using gzip compression, making a new file') triggerFileListChanged! !


!MenuMorph methodsFor: 'construction' stamp: 'jmv 4/19/2011 11:02'!
addServices: services for: served extraLines: linesArray

	services withIndexDo: [:service :i |
		service addServiceFor: served toMenu: self.
		submorphs last setBalloonText: service description.
		(linesArray includes: i) | service useLineAfter 
			ifTrue: [self addLine]].
! !


!ScrollPane methodsFor: 'scroll bar events' stamp: 'jmv 4/19/2011 12:03'!
mouseButton2Activity
	"Invoke the menu"

	self getMenu ifNotNil: [ :menu |
		menu invokeModal ]! !


!SimpleServiceEntry methodsFor: 'accessing' stamp: 'jmv 4/19/2011 11:17'!
triggerFileListChanged
	triggerFileListChanged _ true! !

!SimpleServiceEntry methodsFor: 'performing service' stamp: 'jmv 4/19/2011 11:17'!
performService
	"carry out the service I provide"

	selector numArgs = 0
		ifTrue: [ provider perform: selector ]
		ifFalse: [ provider perform: selector with: (self getArgumentsFrom: argumentProvider) ].
	triggerFileListChanged ifTrue: [
		self changed: #fileListChanged ]! !

!SimpleServiceEntry methodsFor: 'initialize-release' stamp: 'jmv 4/19/2011 11:17'!
initialize
	triggerFileListChanged _ false! !


!TextModelMorph methodsFor: 'menu' stamp: 'jmv 4/19/2011 11:22'!
getMenu

	| menu |
	menu _ MenuMorph new defaultTarget: self.
	^editorClass paneMenu: menu! !


!FileList methodsFor: 'file list menu' stamp: 'jmv 4/19/2011 11:12'!
editorClass
	^SmalltalkEditor! !

!FileList methodsFor: 'file list menu' stamp: 'jmv 4/19/2011 11:07'!
fileSelectedMenu

	| firstItems secondItems thirdItems n1 n2 n3 services aMenu |
	aMenu _ MenuMorph new defaultTarget: self.
	firstItems _ self itemsForFile: self fullName.
	secondItems _ self itemsForAnyFile.
	thirdItems _ self itemsForNoFile.
	n1 _ firstItems size.
	n2 _ n1 + secondItems size.
	n3 _ n2 + thirdItems size.
	services _ firstItems, secondItems, thirdItems, self serviceAllFileOptions.
	services do: [ :svc | svc addDependent: self ].
	^ aMenu 
		addServices: services 
		for: self
		extraLines: (Array with: n1 with: n2 with: n3)
! !

!FileList methodsFor: 'file list menu' stamp: 'jmv 4/19/2011 11:10'!
itemsForAnyFile
	"Answer a list of universal services that could apply to any file"
	
	| services |
	services _ OrderedCollection new.
	(#(briefHex briefFile needToGetBriefHex needToGetBrief) includes: brevityState) ifTrue: [
		services add: self serviceGet ].
	(#(fullHex briefHex needToGetFullHex needToGetBriefHex) includes: brevityState) ifFalse: [
		services add: self serviceGetHex ].
	services add: self serviceCopyName. 
	services add: self serviceRenameFile. 
	services add: self serviceDeleteFile.
	services add: self serviceViewContentsInWorkspace.
	^ services! !

Debugger removeSelector: #perform:orSendTo:!
TextProvider removeSelector: #perform:orSendTo:!
PluggableTextModel removeSelector: #perform:orSendTo:!
TextModel removeSelector: #perform:orSendTo:!
TestRunner removeSelector: #perform:orSendTo:!
String removeSelector: #openAsMorph!
SimpleServiceEntry removeSelector: #perform:orSendTo:!
!classDefinition: #SimpleServiceEntry category: #'Tools-FileList'!
Model subclass: #SimpleServiceEntry
	instanceVariableNames: 'provider label selector useLineAfter stateSelector description argumentGetter buttonLabel argumentProvider triggerFileListChanged'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tools-FileList'!
ProcessBrowser removeSelector: #perform:orSendTo:!
Number removeSelector: #stringForReadout!
MenuMorph removeSelector: #addService:for:!
MenuMorph removeSelector: #addServices2:for:extraLines:!
MenuMorph removeSelector: #setInvokingView:!
CustomMenu removeSelector: #addService:for:!
CustomMenu removeSelector: #addServices2:for:extraLines:!
CustomMenu removeSelector: #addServices:for:extraLines:!
AbstractHierarchicalList removeSelector: #perform:orSendTo:!
Object removeSelector: #openAsMorph!
Object removeSelector: #perform:orSendTo:!
Object removeSelector: #stringForReadout!
Smalltalk removeClassNamed: #FileContentsEditor!
Smalltalk removeClassNamed: #FileModifyingSimpleServiceEntry!
