'From Cuis 3.2 of 12 April 2011 [latest update: #914] on 11 May 2011 at 8:58:11 am'!

!TranscriptMorph commentStamp: '<historical>' prior: 0!
Provide a view for integrating Transcript into the Morphic World.!


!Object methodsFor: 'printing' stamp: 'jmv 5/11/2011 08:48'!
print
	Transcript show: self printString; cr! !


!BareTextMorph methodsFor: 'event handling' stamp: 'jmv 5/11/2011 08:37'!
handlesMouseDown: evt
	^ true! !


!OneLineEditorMorph methodsFor: 'event handling' stamp: 'jmv 5/11/2011 08:37'!
handlesMouseDown: evt
	^ true! !


!String methodsFor: 'printing' stamp: 'jmv 5/11/2011 08:49'!
print
	Transcript show: self; cr! !


!Symbol methodsFor: 'printing' stamp: 'jmv 5/11/2011 08:49'!
print
	Transcript show: self printString; cr! !


!Transcript class methodsFor: 'preferred protocol' stamp: 'FernandoOlivero 5/6/2011 16:04'!
bounds: aRectangle
	innerRectangle _ aRectangle insetBy: self borderWidth + self padding.! !

!Transcript class methodsFor: 'preferred protocol' stamp: 'jmv 5/11/2011 08:53'!
clearAll

	self clearInternal.
	logToFile ifTrue: [
		self clearFile ]! !

!Transcript class methodsFor: 'preferred protocol' stamp: 'jmv 5/11/2011 08:52'!
clearFile
	| stream |
	accessSemaphore critical: [
		stream _ StandardFileStream forceNewFileNamed: self filename.
		[
			stream nextPutAll: 'Transcript log started: '.
			DateAndTime now printOn: stream.
			stream
				lf;
				nextPutAll: '------------------------------------------------------------------------';
				lf
		] ensure: [ stream close ]]! !

!Transcript class methodsFor: 'preferred protocol' stamp: 'jmv 5/11/2011 08:51'!
clearInternal

	accessSemaphore critical: [
		"Having at least one entry simplifies handling of the entries circular collection"
		firstIndex _ 1.
		lastIndex _ 1.
		entries at: 1 put: 'Transcript'.	
		unfinishedEntry reset ].
	self display! !

!Transcript class methodsFor: 'preferred protocol' stamp: 'jmv 5/11/2011 08:41'!
logsToFile
	^logToFile! !

!Transcript class methodsFor: 'private' stamp: 'jmv 2/18/2011 12:34'!
addEntry: aString logToFile: otherString
	"Add a new entrie to the entries circular list. If full, a new entry will replace the oldest one."
	| stream |
	accessSemaphore critical: [
		
		"Internal circular collection"
		lastIndex _ lastIndex \\ self maxEntries + 1.
		firstIndex = lastIndex ifTrue: [
			firstIndex _ firstIndex \\ self maxEntries + 1 ].
		entries at: lastIndex put: aString.
		
		"external file"
		otherString ifNotNil: [
			[
				stream _ StandardFileStream fileNamed: self filename.
				stream
					setToEnd;
					nextPutAll: otherString;
					flush]
			ensure: [ stream close ]
		]
	]! !

!Transcript class methodsFor: 'displaying' stamp: 'jmv 5/11/2011 08:28'!
displayOn: aForm
	"
	Transcript displayOn: Display
	"
	| font port count i string x y fh f bw r |
	bw _ self borderWidth  .
	r _ innerRectangle outsetBy: bw + self padding.
	aForm border: r width: bw. 
	aForm fill: r fillColor: Color white.
	port _ BitBlt toForm: aForm.
	port clipWidth: innerRectangle right.
	font _ StrikeFont default.
	font installOn: port foregroundColor: Color veryDarkGray.
	
	fh _ font height.
	count _ innerRectangle height // fh-1.
	x _ innerRectangle left.
	y _ innerRectangle top.
	f _ firstIndex-1.
	firstIndex > lastIndex ifTrue: [ f _ f - self maxEntries ].
	i _ (lastIndex - count max: f) \\ self maxEntries + 1.
	[
		string _ entries at: i.	
		port displayString: string from: 1 to: string size at: x@y strikeFont: font kern: font baseKern negated.
		y _ y + fh.
		i = lastIndex
	] whileFalse: [ i _ i \\ self maxEntries + 1 ].

	string _ unfinishedEntry contents.	
	port displayString: string from: 1 to: string size at: x@y strikeFont: font kern: font baseKern negated.! !

!Transcript class methodsFor: 'displaying' stamp: 'jmv 5/11/2011 08:44'!
padding
	^ 3! !


!TranscriptMorph methodsFor: 'menus' stamp: 'jmv 5/11/2011 08:57'!
getMenu
	"Set up the menu to apply to the receiver"

	| aMenu |
	aMenu _ MenuMorph new defaultTarget: self.
	aMenu addList: #(
		('edit contents'					editContents)
		-
		('clear Transcript object'		clearInternal)
		('clear Transcript file'			clearFile)
		('clear both'					clearAll)
		-).
	Transcript logsToFile
		ifTrue: [ aMenu addList: #(('stop logging to file'		dontLogToFile)) ]
		ifFalse: [ aMenu addList: #(('start logging to file'	logToFile)) ].
	^ aMenu! !

!TranscriptMorph methodsFor: 'menus' stamp: 'jmv 5/11/2011 08:38'!
handlesMouseDown: evt
	^ true! !

!TranscriptMorph methodsFor: 'menus' stamp: 'jmv 5/11/2011 08:38'!
mouseDown: event
	"Invoke the menu"
	event mouseButton2Pressed ifTrue: [
		self getMenu ifNotNil: [ :menu |
			menu invokeModal ].
		^self ].

	super mouseDown: event! !

!TranscriptMorph methodsFor: 'menu commands' stamp: 'jmv 5/11/2011 08:54'!
clearAll
	Transcript clearAll! !

!TranscriptMorph methodsFor: 'menu commands' stamp: 'jmv 5/11/2011 08:54'!
clearFile
	Transcript clearFile! !

!TranscriptMorph methodsFor: 'menu commands' stamp: 'jmv 5/11/2011 08:54'!
clearInternal
	Transcript clearInternal! !

!TranscriptMorph methodsFor: 'menu commands' stamp: 'jmv 5/11/2011 08:41'!
dontLogToFile
	Transcript logToFile: false! !

!TranscriptMorph methodsFor: 'menu commands' stamp: 'jmv 5/11/2011 08:40'!
editContents
	Transcript contents edit! !

!TranscriptMorph methodsFor: 'menu commands' stamp: 'jmv 5/11/2011 08:40'!
logToFile
	Transcript logToFile: true! !

TranscriptMorph removeSelector: #clear!

!TranscriptMorph reorganize!
('drawing' drawOn:)
('geometry' extent:)
('menus' getMenu handlesMouseDown: mouseDown:)
('menu commands' clearAll clearFile clearInternal dontLogToFile editContents logToFile)
!

