'From Cuis 3.2 of 12 April 2011 [latest update: #914] on 18 May 2011 at 10:07:04 pm'!

!Preferences class methodsFor: 'menu icons' stamp: 'cbr 5/16/2011 16:53'!
useAllIcons

	self setPreference: #menuIcons toValue: #allIcons.
! !

!Preferences class methodsFor: 'menu icons' stamp: 'cbr 5/16/2011 16:53'!
useBasicIcons

	self setPreference: #menuIcons toValue: #basicIcons.
! !

!Preferences class methodsFor: 'menu icons' stamp: 'cbr 5/16/2011 16:53'!
useNoIcons

	self setPreference: #menuIcons toValue: #noIcons.
! !


!TheWorldMenu methodsFor: 'construction' stamp: 'cbr 5/16/2011 16:46'!
appearanceMenu
	"Build the appearance menu for the world."
	
	^self fillIn: (self menu: 'appearance...') from: {
		{'themes...' . {Theme . #changeTheme} . 'switch to another theme.'}.
		{'icons...' . {Theme . #changeIcons} . 'show more or less icons.'}.
		nil.
		{'show taskbar' . {Taskbar . #show} . 'show the taskbar'}.
		{'hide taskbar' . {Taskbar . #hide} . 'hide the taskbar'}.
		nil.
		{'system fonts...' . { self . #standardFontDo} . 'Choose the standard fonts to use for code, lists, menus, window titles, etc.'}.
		nil.
		{'full screen on' . { self . #fullScreenOn} . 'puts you in full-screen mode, if not already there.'}.
		{'full screen off' . { self . #fullScreenOff} . 'if in full-screen mode, takes you out of it.'}.
		nil.
		{'set display depth...' . {self. #setDisplayDepth} . 'choose how many bits per pixel.'}.
		{'set desktop color...' . {self. #changeBackgroundColor} . 'choose a uniform color to use as desktop background.'}.
	}! !


!Theme methodsFor: 'menus' stamp: 'cbr 5/16/2011 17:11'!
basicIcons

"Minimal menu scheme."

	^ { 
		#('open...') -> #openIcon.
		#('windows...' 'find window') -> #windowIcon.
		#('help...' 'explain' 'about this system...') -> #helpIcon.
		#('appearance...' 'themes...') -> #appearanceIcon.
		#('do...' 'Cursor normal show.' 'do it (d)') -> #doItIcon.
		#('new morph...' 'objects (o)' 'save world as morph file') -> #morphsIcon.
		#('save' 'save project on file...' ) -> #saveIcon.
		#('save as...' 'change category...' 'rename change set (r)' 'rename') -> #saveAsIcon.
		#('save as new version') -> #saveAsNewVersionIcon.
		#('quit') -> #quitIcon.
		#('save and quit' ) -> #saveAndQuitIcon.
		#('inspect it (i)' 'inspect world'  'inspect model' 'inspect morph'
		 'inspect owner chain' 'inspect' 'inspect (i)' 'basic inspect' 'message names' 'find message names' 'inspect instances' 'inspect subinstances' 'inspect change set' 'inspect context (c)' 'inspect receiver (i)' 'start CPUWatcher')
			-> #inspectIcon.
		#('explore' 'explore it (I)' 'explore world' 'explore morph' 'explore (I)' 'explore context (C)' 'explore receiver (I)') -> #exploreIcon.
		#('find...(f)' 'find class... (f)' 'find method...' 'find recent submissions' 'show hierarchy' 'show definition' 'show comment' 'filter' 'filter message list...' 'find context... (f)') -> #findIcon.
		#('add item...' 'new category...' 'create new change set...' 'new change set... (n)' 'add new file') -> #newIcon.
		#('remove method (x)' 'remove' 'remove class (x)' 'remove method from system (x)' 'remove class from system (x)' 'remove postscript') -> #deleteIcon.
		#('delete method from changeset (d)' 'delete class from change set (d)' 'destroy change set (X)' 'revert & remove from changes' 'delete unchanged windows' 'delete non-windows' 'delete both of the above' 'reset variables' 'remove contained in class categories...' 'clear this change set' 'uninstall this change set' 'delete directory...' 'delete') -> #warningIcon.
		#('do again (j)' ) -> #redoIcon.
		#('undo (z)' 'revert to previous version') -> #undoIcon.
		#('copy (c)' 'copy class...' 'copy class chgs to other side' 'copy method to other side' 'copy all to other side (c)' 'copy name to clipboard' 'copy selector to clipboard') -> #copyIcon.
		#('paste (v)') -> #pasteIcon.
		#('cut (x)' 'move class chgs to other side' 'move method to other side' 'submerge into other side') -> #cutIcon.
		#('paste...' 'icons...') -> #worldIcon.
}! !


!Theme class methodsFor: 'user interface' stamp: 'cbr 5/16/2011 16:58'!
changeIcons

	| menu selector |
	
	menu _ SelectionMenu
		fromArray: #(
			#( 'use basic icons' #useBasicIcons )
			#( 'use all icons' #useAllIcons )
			#( 'use no icons' #useNoIcons )
		).
			
	selector _ menu startUpWithCaption: 'Select desired icon density'.
	
	Preferences perform: selector.
	
	Theme current class beCurrent
! !

!Theme class methodsFor: 'user interface' stamp: 'cbr 5/16/2011 16:44'!
changeTheme

	| themes set menu result |
		themes _ Theme allSubclasses copyWith: Theme.
		set _ themes collect: [ :i | { i asString . i } ].
		menu _ SelectionMenu fromArray: set asArray.
		result _ menu startUpWithCaption: 'Choose a theme'.

	result beCurrent
! !

Theme class removeSelector: #change!

!Theme class reorganize!
('instance creation' beCurrent)
('accessing' content content: current)
('importing/exporting' bootstrap)
('class initialization' currentTheme:)
('user interface' changeIcons changeTheme)
!


!Preferences class reorganize!
('add preferences' addPreference:categories:default:balloonHelp: addPreference:categories:default:balloonHelp:changeInformee:changeSelector: addPreference:category:default:balloonHelp:)
('fonts' chooseBalloonHelpFont chooseCodeFont chooseFontWithPrompt:andSendTo:withSelector:highlight: chooseListFont chooseMenuFont chooseSystemFont chooseWindowTitleFont fontConfigurationMenu printStandardSystemFonts properDisplayAlphaForFonts restoreDefaultFonts setBalloonHelpFontTo: setButtonFontTo: setCodeFontTo: setDefaultFonts: setListFontTo: setMenuFontTo: setSystemFontTo: setWindowTitleFontTo: standardBalloonHelpFont standardButtonFont standardCodeFont standardListFont standardMenuFont subPixelRenderColorFonts subPixelRenderFonts windowTitleFont)
('get/set' disable: doesNotUnderstand: enable: setPreference:toValue: togglePreference: valueOfFlag: valueOfFlag:ifAbsent:)
('halos' haloSpecifications haloSpecificationsForWorld iconicHaloSpecifications installHaloSpecsFromArray: installHaloTheme: resetHaloSpecifications)
('hard-coded prefs' desktopMenuTitle)
('initialization' chooseInitialSettings compileAccessMethodForPreference: initializeDictionaryOfPreferences removeParameter: removePreference: setPreferencesFrom:)
('menu parameters' menuBorderWidth menuTitleBorderWidth restoreDefaultMenuParameters)
('misc' addModelItemsToWindowMenu: cleanUp inspectUnused inspectUnusedParameters setFlag:toValue:during: staggerPolicyString toggleWindowPolicy wantsChangeSetLogging)
('parameters' annotationInfo defaultAnnotationRequests defaultAuthorName initializeParameters inspectParameters maxBalloonHelpLineLength parameterAt:ifAbsent: parameterAt:ifAbsentPut: setDefaultAnnotationInfo setParameter:to:)
('personalization' compileHardCodedPref:enable: disableProgrammerFacilities enableProgrammerFacilities)
('preference-object access' allPreferenceObjects preferenceAt: preferenceAt:ifAbsent:)
('preferences panel' openPreferencesInspector)
('reacting to change' setNotificationParametersForStandardPreferences smartUpdatingChanged)
('scrollbar parameters' scrollbarThickness)
('standard queries' aaFontsColormapDepth allowBlockArgumentAssignment allowUnderscoreAssignments allowUnderscoreSelectors alternativeBrowseIt automaticPlatformSettings balloonHelpEnabled biggerCursors browseWithPrettyPrint canRecordWhilePlaying caseSensitiveFinds changeSetVersionNumbers checkForSlips classicNewMorphMenu cmdDotEnabled collapseWindowsInPlace conversionMethodsAtFileOut debugHaloHandle debugLogTimestamp debugShowDamage decorateBrowserButtons diffsInChangeList diffsWithPrettyPrint dismissAllOnOptionClose extraDebuggerButtons fastDragWindowForMorphic focusFollowsMouse focusIndicatorWidth fullScreenLeavesDeskMargins haloEnclosesFullBounds higherPerformance logDebuggerStackToFile menuIcons menuKeyboardControl menuWithIcons modalColorPickers optionalButtons prettyPrintRectangularBlocks reverseWindowStagger selectionsMayShrink selectiveHalos serverMode showBoundsInHalo showLinesInHierarchyViews simpleMenus smartUpdating soundQuickStart soundStopWhenDone soundsEnabled systemWindowEmbedOK thoroughSenders twentyFourHourFileStamps warnIfNoChangesFile warnIfNoSourcesFile wordStyleCursorMovement)
('menu icons' useAllIcons useBasicIcons useNoIcons)
('themes' juans slowMachine smalltalk80)
('shout' shoutInWorkspaces syntaxHighlightingAsYouType syntaxHighlightingAsYouTypeAnsiAssignment syntaxHighlightingAsYouTypeLeftArrowAssignment)
('bigger and smaller GUI' bigFonts hugeFonts smallFonts standardFonts tinyFonts veryBigFonts verySmallFonts)
!

